## Connection and Channel ServicePoint interfaces

Connection and Channel ServicePoint interfaces — client-side wrappers for the ServicePoint interfaces

## Functions

TpProxySignalConnection * | tp_cli_channel_interface_service_point_connect_to_service_point_changed ()
void | (*tp_cli_channel_interface_service_point_signal_callback_service_point_changed) ()
TpProxySignalConnection * | tp_cli_connection_interface_service_point_connect_to_service_points_changed ()
void | (*tp_cli_connection_interface_service_point_signal_callback_service_points_changed) ()

## Includes

    #include <telepathy-glib/telepathy-glib-dbus.h>

## Description

In some protocols, mainly those that interact with the PSTN, it's possible to contact the emergency services or other public service answering points. The ServicePoint interfaces on the Connection and Channel can be used to discover how to contact these service points, and detect whether a call in progress is communicating with a service point.

This section documents the auto-generated C wrappers for the ServicePoint interfaces, used with TpConnection and TpChannel objects.

## Functions

### tp_cli_channel_interface_service_point_connect_to_service_point_changed ()

    TpProxySignalConnection *
    tp_cli_channel_interface_service_point_connect_to_service_point_changed
                                   (TpChannel *proxy,
                                    tp_cli_channel_interface_service_point_signal_callback_service_point_changed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal ServicePointChanged.

<p>Emitted when a channel changes the service point that it's connected to. This might be a new call being connected to a service, a call connected to a service being routed to a different service (ie, an emergency call being routed from a generic emergency PSAP to a poison control PSAP), or any number of other things.</p> <p>Note that this should be emitted as soon as the CM has been notified of the switch, and has updated its internal state. The CM MAY still be in the process of connecting to the new service point.</p>

#### Parameters

proxy | A TpChannel or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_channel_interface_service_point_signal_callback_service_point_changed ()

    void
    (*tp_cli_channel_interface_service_point_signal_callback_service_point_changed)
                                   (TpChannel *proxy,
                                    const GValueArray *arg_Service_Point,
                                    gpointer user_data,
                                    GObject *weak_object);

`tp_cli_channel_interface_service_point_signal_callback_service_point_changed` is deprecated and should not be used in newly-written code.

Represents the signature of a callback for the signal ServicePointChanged.

#### Parameters

proxy | The proxy on which `tp_cli_channel_interface_service_point_connect_to_service_point_changed()` was called |
arg_Service_Point | The new service point that is being used. |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_connection_interface_service_point_connect_to_service_points_changed ()

    TpProxySignalConnection *
    tp_cli_connection_interface_service_point_connect_to_service_points_changed
                                   (TpConnection *proxy,
                                    tp_cli_connection_interface_service_point_signal_callback_service_points_changed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal ServicePointsChanged.

Emitted when the list of known service points (or their IDs) has changed.

#### Parameters

proxy | A TpConnection or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_connection_interface_service_point_signal_callback_service_points_changed ()

    void
    (*tp_cli_connection_interface_service_point_signal_callback_service_points_changed)
                                   (TpConnection *proxy,
                                    const GPtrArray *arg_Service_Points,
                                    gpointer user_data,
                                    GObject *weak_object);

`tp_cli_connection_interface_service_point_signal_callback_service_points_changed` is deprecated and should not be used in newly-written code.

Represents the signature of a callback for the signal ServicePointsChanged.

#### Parameters

proxy | The proxy on which `tp_cli_connection_interface_service_point_connect_to_service_points_changed()` was called |
arg_Service_Points | <tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>The new value of <tp:member-ref>KnownServicePoints</tp:member-ref>.</p> |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

## Types and Values

## See Also

TpConnection, TpChannel